require '_h2ph_pre.ph';

unless(defined(&__ALPHA_POLARIS__H__)) {
    eval 'sub __ALPHA_POLARIS__H__ () {1;}' unless defined(&__ALPHA_POLARIS__H__);
    require 'linux/config.ph';
    require 'linux/types.ph';
    require 'asm/compiler.ph';
    eval 'sub POLARIS_SPARSE_MEM_BASE () {( &IDENT_ADDR + 0xf800000000);}' unless defined(&POLARIS_SPARSE_MEM_BASE);
    eval 'sub POLARIS_DENSE_MEM_BASE () {( &IDENT_ADDR + 0xf900000000);}' unless defined(&POLARIS_DENSE_MEM_BASE);
    eval 'sub POLARIS_SPARSE_IO_BASE () {( &IDENT_ADDR + 0xf980000000);}' unless defined(&POLARIS_SPARSE_IO_BASE);
    eval 'sub POLARIS_SPARSE_CONFIG_BASE () {( &IDENT_ADDR + 0xf9c0000000);}' unless defined(&POLARIS_SPARSE_CONFIG_BASE);
    eval 'sub POLARIS_IACK_BASE () {( &IDENT_ADDR + 0xf9f8000000);}' unless defined(&POLARIS_IACK_BASE);
    eval 'sub POLARIS_DENSE_IO_BASE () {( &IDENT_ADDR + 0xf9fc000000);}' unless defined(&POLARIS_DENSE_IO_BASE);
    eval 'sub POLARIS_DENSE_CONFIG_BASE () {( &IDENT_ADDR + 0xf9fe000000);}' unless defined(&POLARIS_DENSE_CONFIG_BASE);
    eval 'sub POLARIS_IACK_SC () { &POLARIS_IACK_BASE;}' unless defined(&POLARIS_IACK_SC);
    eval 'sub POLARIS_W_VENID () {( &POLARIS_DENSE_CONFIG_BASE);}' unless defined(&POLARIS_W_VENID);
    eval 'sub POLARIS_W_DEVID () {( &POLARIS_DENSE_CONFIG_BASE+2);}' unless defined(&POLARIS_W_DEVID);
    eval 'sub POLARIS_W_CMD () {( &POLARIS_DENSE_CONFIG_BASE+4);}' unless defined(&POLARIS_W_CMD);
    eval 'sub POLARIS_W_STATUS () {( &POLARIS_DENSE_CONFIG_BASE+6);}' unless defined(&POLARIS_W_STATUS);
    eval 'sub POLARIS_DMA_WIN_BASE_DEFAULT () {0x80000000;}' unless defined(&POLARIS_DMA_WIN_BASE_DEFAULT);
    eval 'sub POLARIS_DMA_WIN_SIZE_DEFAULT () {0x80000000;}' unless defined(&POLARIS_DMA_WIN_SIZE_DEFAULT);
    if(defined( &CONFIG_ALPHA_GENERIC) || defined( &CONFIG_ALPHA_SRM_SETUP)) {
	eval 'sub POLARIS_DMA_WIN_BASE () { ($alpha_mv->{dma_win_base});}' unless defined(&POLARIS_DMA_WIN_BASE);
	eval 'sub POLARIS_DMA_WIN_SIZE () { ($alpha_mv->{dma_win_size});}' unless defined(&POLARIS_DMA_WIN_SIZE);
    } else {
	eval 'sub POLARIS_DMA_WIN_BASE () { &POLARIS_DMA_WIN_BASE_DEFAULT;}' unless defined(&POLARIS_DMA_WIN_BASE);
	eval 'sub POLARIS_DMA_WIN_SIZE () { &POLARIS_DMA_WIN_SIZE_DEFAULT;}' unless defined(&POLARIS_DMA_WIN_SIZE);
    }
    if(defined(&__KERNEL__)) {
	unless(defined(&__EXTERN_INLINE)) {
	    eval 'sub __EXTERN_INLINE () { &extern  &inline;}' unless defined(&__EXTERN_INLINE);
	    eval 'sub __IO_EXTERN_INLINE () {1;}' unless defined(&__IO_EXTERN_INLINE);
	}
	eval 'sub vucp () { &volatile \'unsigned char\' *;}' unless defined(&vucp);
	eval 'sub vusp () { &volatile \'unsigned short\' *;}' unless defined(&vusp);
	eval 'sub vuip () { &volatile \'unsigned int\' *;}' unless defined(&vuip);
	eval 'sub vulp () { &volatile \'unsigned long\' *;}' unless defined(&vulp);
	undef(&vucp) if defined(&vucp);
	undef(&vusp) if defined(&vusp);
	undef(&vuip) if defined(&vuip);
	undef(&vulp) if defined(&vulp);
	if(defined(&__WANT_IO_DEF)) {
	    eval 'sub virt_to_bus () { &polaris_virt_to_bus;}' unless defined(&virt_to_bus);
	    eval 'sub bus_to_virt () { &polaris_bus_to_virt;}' unless defined(&bus_to_virt);
	    eval 'sub __inb () { &polaris_inb;}' unless defined(&__inb);
	    eval 'sub __inw () { &polaris_inw;}' unless defined(&__inw);
	    eval 'sub __inl () { &polaris_inl;}' unless defined(&__inl);
	    eval 'sub __outb () { &polaris_outb;}' unless defined(&__outb);
	    eval 'sub __outw () { &polaris_outw;}' unless defined(&__outw);
	    eval 'sub __outl () { &polaris_outl;}' unless defined(&__outl);
	    eval 'sub __readb () { &polaris_readb;}' unless defined(&__readb);
	    eval 'sub __readw () { &polaris_readw;}' unless defined(&__readw);
	    eval 'sub __writeb () { &polaris_writeb;}' unless defined(&__writeb);
	    eval 'sub __writew () { &polaris_writew;}' unless defined(&__writew);
	    eval 'sub __readl () { &polaris_readl;}' unless defined(&__readl);
	    eval 'sub __readq () { &polaris_readq;}' unless defined(&__readq);
	    eval 'sub __writel () { &polaris_writel;}' unless defined(&__writel);
	    eval 'sub __writeq () { &polaris_writeq;}' unless defined(&__writeq);
	    eval 'sub dense_mem () { &polaris_dense_mem;}' unless defined(&dense_mem);
	    eval 'sub inb {
	        local($port) = @_;
    		eval q( &__inb(($port)));
	    }' unless defined(&inb);
	    eval 'sub inw {
	        local($port) = @_;
    		eval q( &__inw(($port)));
	    }' unless defined(&inw);
	    eval 'sub inl {
	        local($port) = @_;
    		eval q( &__inl(($port)));
	    }' unless defined(&inl);
	    eval 'sub outb {
	        local($v, $port) = @_;
    		eval q( &__outb(($v),($port)));
	    }' unless defined(&outb);
	    eval 'sub outw {
	        local($v, $port) = @_;
    		eval q( &__outw(($v),($port)));
	    }' unless defined(&outw);
	    eval 'sub outl {
	        local($v, $port) = @_;
    		eval q( &__outl(($v),($port)));
	    }' unless defined(&outl);
	    eval 'sub readb {
	        local($a) = @_;
    		eval q( &__readb(($a)));
	    }' unless defined(&readb);
	    eval 'sub readw {
	        local($a) = @_;
    		eval q( &__readw(($a)));
	    }' unless defined(&readw);
	    eval 'sub readl {
	        local($a) = @_;
    		eval q( &__readl(($a)));
	    }' unless defined(&readl);
	    eval 'sub readq {
	        local($a) = @_;
    		eval q( &__readq(($a)));
	    }' unless defined(&readq);
	    eval 'sub writeb {
	        local($v,$a) = @_;
    		eval q( &__writeb(,($a)));
	    }' unless defined(&writeb);
	    eval 'sub writew {
	        local($v,$a) = @_;
    		eval q( &__writew(,($a)));
	    }' unless defined(&writew);
	    eval 'sub writel {
	        local($v,$a) = @_;
    		eval q( &__writel(,($a)));
	    }' unless defined(&writel);
	    eval 'sub writeq {
	        local($v,$a) = @_;
    		eval q( &__writeq(,($a)));
	    }' unless defined(&writeq);
	}
	if(defined(&__IO_EXTERN_INLINE)) {
	    undef(&__EXTERN_INLINE) if defined(&__EXTERN_INLINE);
	    undef(&__IO_EXTERN_INLINE) if defined(&__IO_EXTERN_INLINE);
	}
    }
}
1;
