require '_h2ph_pre.ph';

unless(defined(&_ALPHA_PGTABLE_H)) {
    eval 'sub _ALPHA_PGTABLE_H () {1;}' unless defined(&_ALPHA_PGTABLE_H);
    require 'linux/config.ph';
    require 'asm/system.ph';
    require 'asm/processor.ph';
    require 'asm/mmu_context.ph';
    require 'asm/machvec.ph';
    require 'asm/spinlock.ph';
    eval 'sub flush_cache_all () {
        eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_all);
    eval 'sub flush_cache_mm {
        local($mm) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_mm);
    eval 'sub flush_cache_range {
        local($mm, $start, $end) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_range);
    eval 'sub flush_cache_page {
        local($vma, $vmaddr) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_page);
    eval 'sub flush_page_to_ram {
        local($page) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_page_to_ram);
    eval 'sub flush_icache_range {
        local($start, $end) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_icache_range);
    unless(defined(&__EXTERN_INLINE)) {
	eval 'sub __EXTERN_INLINE () { &extern  &inline;}' unless defined(&__EXTERN_INLINE);
	eval 'sub __MMU_EXTERN_INLINE () {1;}' unless defined(&__MMU_EXTERN_INLINE);
    }
    if(defined(&CONFIG_ALPHA_GENERIC)) {
	eval 'sub flush_tlb_current () { ($alpha_mv->{mv_flush_tlb_current});}' unless defined(&flush_tlb_current);
	eval 'sub flush_tlb_other () { ($alpha_mv->{mv_flush_tlb_other});}' unless defined(&flush_tlb_other);
	eval 'sub flush_tlb_current_page () { ($alpha_mv->{mv_flush_tlb_current_page});}' unless defined(&flush_tlb_current_page);
    } else {
	if(defined(&CONFIG_ALPHA_EV4)) {
	    eval 'sub flush_tlb_current () { &ev4_flush_tlb_current;}' unless defined(&flush_tlb_current);
	    eval 'sub flush_tlb_other () { &ev4_flush_tlb_other;}' unless defined(&flush_tlb_other);
	    eval 'sub flush_tlb_current_page () { &ev4_flush_tlb_current_page;}' unless defined(&flush_tlb_current_page);
	} else {
	    eval 'sub flush_tlb_current () { &ev5_flush_tlb_current;}' unless defined(&flush_tlb_current);
	    eval 'sub flush_tlb_other () { &ev5_flush_tlb_other;}' unless defined(&flush_tlb_other);
	    eval 'sub flush_tlb_current_page () { &ev5_flush_tlb_current_page;}' unless defined(&flush_tlb_current_page);
	}
    }
    if(defined(&__MMU_EXTERN_INLINE)) {
	undef(&__EXTERN_INLINE) if defined(&__EXTERN_INLINE);
	undef(&__MMU_EXTERN_INLINE) if defined(&__MMU_EXTERN_INLINE);
    }
    unless(defined(&__SMP__)) {
    } else {
    }
    eval 'sub set_pte {
        local($pteptr, $pteval) = @_;
	    eval q(((*($pteptr)) = ($pteval)));
    }' unless defined(&set_pte);
    eval 'sub PMD_SHIFT () {( &PAGE_SHIFT + ( &PAGE_SHIFT-3));}' unless defined(&PMD_SHIFT);
    eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
    eval 'sub PGDIR_SHIFT () {( &PAGE_SHIFT + 2*( &PAGE_SHIFT-3));}' unless defined(&PGDIR_SHIFT);
    eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
    eval 'sub PTRS_PER_PTE () {(1 << ( &PAGE_SHIFT-3));}' unless defined(&PTRS_PER_PTE);
    eval 'sub PTRS_PER_PMD () {(1 << ( &PAGE_SHIFT-3));}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PGD () {((1 << ( &PAGE_SHIFT-3))-1);}' unless defined(&PTRS_PER_PGD);
    eval 'sub USER_PTRS_PER_PGD () {( &TASK_SIZE /  &PGDIR_SIZE);}' unless defined(&USER_PTRS_PER_PGD);
    eval 'sub PTRS_PER_PAGE () {(1 << ( &PAGE_SHIFT-3));}' unless defined(&PTRS_PER_PAGE);
    eval 'sub VMALLOC_START () {0xfffffe0000000000;}' unless defined(&VMALLOC_START);
    eval 'sub VMALLOC_VMADDR {
        local($x) = @_;
	    eval q((($x)));
    }' unless defined(&VMALLOC_VMADDR);
    eval 'sub VMALLOC_END () {(~0);}' unless defined(&VMALLOC_END);
    eval 'sub _PAGE_VALID () {0x0001;}' unless defined(&_PAGE_VALID);
    eval 'sub _PAGE_FOR () {0x0002;}' unless defined(&_PAGE_FOR);
    eval 'sub _PAGE_FOW () {0x0004;}' unless defined(&_PAGE_FOW);
    eval 'sub _PAGE_FOE () {0x0008;}' unless defined(&_PAGE_FOE);
    eval 'sub _PAGE_ASM () {0x0010;}' unless defined(&_PAGE_ASM);
    eval 'sub _PAGE_KRE () {0x0100;}' unless defined(&_PAGE_KRE);
    eval 'sub _PAGE_URE () {0x0200;}' unless defined(&_PAGE_URE);
    eval 'sub _PAGE_KWE () {0x1000;}' unless defined(&_PAGE_KWE);
    eval 'sub _PAGE_UWE () {0x2000;}' unless defined(&_PAGE_UWE);
    eval 'sub _PAGE_DIRTY () {0x20000;}' unless defined(&_PAGE_DIRTY);
    eval 'sub _PAGE_ACCESSED () {0x40000;}' unless defined(&_PAGE_ACCESSED);
    eval 'sub __DIRTY_BITS () {( &_PAGE_DIRTY |  &_PAGE_KWE |  &_PAGE_UWE);}' unless defined(&__DIRTY_BITS);
    eval 'sub __ACCESS_BITS () {( &_PAGE_ACCESSED |  &_PAGE_KRE |  &_PAGE_URE);}' unless defined(&__ACCESS_BITS);
    eval 'sub _PFN_MASK () {0xffffffff00000000;}' unless defined(&_PFN_MASK);
    eval 'sub _PAGE_TABLE () {( &_PAGE_VALID |  &__DIRTY_BITS |  &__ACCESS_BITS);}' unless defined(&_PAGE_TABLE);
    eval 'sub _PAGE_CHG_MASK () {( &_PFN_MASK |  &__DIRTY_BITS |  &__ACCESS_BITS);}' unless defined(&_PAGE_CHG_MASK);
    eval 'sub PAGE_NONE () { &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS |  &_PAGE_FOR |  &_PAGE_FOW |  &_PAGE_FOE);}' unless defined(&PAGE_NONE);
    eval 'sub PAGE_SHARED () { &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS);}' unless defined(&PAGE_SHARED);
    eval 'sub PAGE_COPY () { &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS |  &_PAGE_FOW);}' unless defined(&PAGE_COPY);
    eval 'sub PAGE_READONLY () { &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS |  &_PAGE_FOW);}' unless defined(&PAGE_READONLY);
    eval 'sub PAGE_KERNEL () { &__pgprot( &_PAGE_VALID |  &_PAGE_ASM |  &_PAGE_KRE |  &_PAGE_KWE);}' unless defined(&PAGE_KERNEL);
    eval 'sub _PAGE_NORMAL {
        local($x) = @_;
	    eval q( &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS | ($x)));
    }' unless defined(&_PAGE_NORMAL);
    eval 'sub _PAGE_P {
        local($x) = @_;
	    eval q( &_PAGE_NORMAL(($x) | ((($x) &  &_PAGE_FOW)?0: &_PAGE_FOW)));
    }' unless defined(&_PAGE_P);
    eval 'sub _PAGE_S {
        local($x) = @_;
	    eval q( &_PAGE_NORMAL($x));
    }' unless defined(&_PAGE_S);
    eval 'sub __P000 () { &_PAGE_P( &_PAGE_FOE |  &_PAGE_FOW |  &_PAGE_FOR);}' unless defined(&__P000);
    eval 'sub __P001 () { &_PAGE_P( &_PAGE_FOE |  &_PAGE_FOW);}' unless defined(&__P001);
    eval 'sub __P010 () { &_PAGE_P( &_PAGE_FOE);}' unless defined(&__P010);
    eval 'sub __P011 () { &_PAGE_P( &_PAGE_FOE);}' unless defined(&__P011);
    eval 'sub __P100 () { &_PAGE_P( &_PAGE_FOW |  &_PAGE_FOR);}' unless defined(&__P100);
    eval 'sub __P101 () { &_PAGE_P( &_PAGE_FOW);}' unless defined(&__P101);
    eval 'sub __P110 () { &_PAGE_P(0);}' unless defined(&__P110);
    eval 'sub __P111 () { &_PAGE_P(0);}' unless defined(&__P111);
    eval 'sub __S000 () { &_PAGE_S( &_PAGE_FOE |  &_PAGE_FOW |  &_PAGE_FOR);}' unless defined(&__S000);
    eval 'sub __S001 () { &_PAGE_S( &_PAGE_FOE |  &_PAGE_FOW);}' unless defined(&__S001);
    eval 'sub __S010 () { &_PAGE_S( &_PAGE_FOE);}' unless defined(&__S010);
    eval 'sub __S011 () { &_PAGE_S( &_PAGE_FOE);}' unless defined(&__S011);
    eval 'sub __S100 () { &_PAGE_S( &_PAGE_FOW |  &_PAGE_FOR);}' unless defined(&__S100);
    eval 'sub __S101 () { &_PAGE_S( &_PAGE_FOW);}' unless defined(&__S101);
    eval 'sub __S110 () { &_PAGE_S(0);}' unless defined(&__S110);
    eval 'sub __S111 () { &_PAGE_S(0);}' unless defined(&__S111);
    eval 'sub BAD_PAGETABLE () { &__bad_pagetable();}' unless defined(&BAD_PAGETABLE);
    eval 'sub BAD_PAGE () { &__bad_page();}' unless defined(&BAD_PAGE);
    eval 'sub ZERO_PAGE {
        local($vaddr) = @_;
	    eval q(( &PAGE_OFFSET+0x30a000));
    }' unless defined(&ZERO_PAGE);
    eval 'sub BITS_PER_PTR () {(8*$sizeof{\'unsigned long\'});}' unless defined(&BITS_PER_PTR);
    eval 'sub PTR_MASK () {(~($sizeof{ &void}-1));}' unless defined(&PTR_MASK);
    eval 'sub SIZEOF_PTR_LOG2 () {3;}' unless defined(&SIZEOF_PTR_LOG2);
    eval 'sub PAGE_PTR {
        local($address) = @_;
	    eval q((($address)>>( &PAGE_SHIFT- &SIZEOF_PTR_LOG2) &PTR_MASK&~ &PAGE_MASK));
    }' unless defined(&PAGE_PTR);
    if(defined( &CONFIG_ALPHA_GENERIC)  && defined( &USE_48_BIT_KSEG)) {
	die("EV6-only feature in a generic kernel");
    }
    if(defined( &CONFIG_ALPHA_GENERIC) || (defined( &CONFIG_ALPHA_EV6)  && !defined( &USE_48_BIT_KSEG))) {
	eval 'sub PHYS_TWIDDLE {
	    local($phys) = @_;
    	    eval q((((($phys) & 0xc0000000000) == 0x40000000000) ? (($phys) ^= 0xc0000000000) : ($phys)));
	}' unless defined(&PHYS_TWIDDLE);
    } else {
	eval 'sub PHYS_TWIDDLE {
	    local($phys) = @_;
    	    eval q(($phys));
	}' unless defined(&PHYS_TWIDDLE);
    }
    eval 'sub PAGE_DIR_OFFSET {
        local($tsk,$address) = @_;
	    eval q( &pgd_offset(($tsk),($address)));
    }' unless defined(&PAGE_DIR_OFFSET);
    eval 'sub pgd_offset_k {
        local($address) = @_;
	    eval q( &pgd_offset( &init_mm, $address));
    }' unless defined(&pgd_offset_k);
    unless(defined(&__SMP__)) {
    } else {
	require 'asm/smp.ph';
	eval 'sub quicklists () { $cpu_data[ &smp_processor_id()];}' unless defined(&quicklists);
    }
    eval 'sub pgd_quicklist () {( ($quicklists->{pgd_cache}));}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {(0);}' unless defined(&pmd_quicklist);
    eval 'sub pte_quicklist () {( ($quicklists->{pte_cache}));}' unless defined(&pte_quicklist);
    eval 'sub pgtable_cache_size () {( ($quicklists->{pgtable_cache_sz}));}' unless defined(&pgtable_cache_size);
    eval 'sub pte_free_kernel {
        local($pte) = @_;
	    eval q( &free_pte_fast($pte));
    }' unless defined(&pte_free_kernel);
    eval 'sub pte_free {
        local($pte) = @_;
	    eval q( &free_pte_fast($pte));
    }' unless defined(&pte_free);
    eval 'sub pmd_free_kernel {
        local($pmd) = @_;
	    eval q( &free_pmd_fast($pmd));
    }' unless defined(&pmd_free_kernel);
    eval 'sub pmd_free {
        local($pmd) = @_;
	    eval q( &free_pmd_fast($pmd));
    }' unless defined(&pmd_free);
    eval 'sub pgd_free {
        local($pgd) = @_;
	    eval q( &free_pgd_fast($pgd));
    }' unless defined(&pgd_free);
    eval 'sub pgd_alloc () {
        eval q( &get_pgd_fast());
    }' unless defined(&pgd_alloc);
    eval 'sub pte_alloc_kernel () { &pte_alloc;}' unless defined(&pte_alloc_kernel);
    eval 'sub pmd_alloc_kernel () { &pmd_alloc;}' unless defined(&pmd_alloc_kernel);
    eval 'sub SWP_TYPE {
        local($entry) = @_;
	    eval q(((($entry) >> 32) & 0xff));
    }' unless defined(&SWP_TYPE);
    eval 'sub SWP_OFFSET {
        local($entry) = @_;
	    eval q((($entry) >> 40));
    }' unless defined(&SWP_OFFSET);
    eval 'sub SWP_ENTRY {
        local($type,$offset) = @_;
	    eval q( &pte_val( &mk_swap_pte(($type),($offset))));
    }' unless defined(&SWP_ENTRY);
    eval 'sub module_map () { &vmalloc;}' unless defined(&module_map);
    eval 'sub module_unmap () { &vfree;}' unless defined(&module_unmap);
    eval 'sub PageSkip {
        local($page) = @_;
	    eval q((0));
    }' unless defined(&PageSkip);
    eval 'sub kern_addr_valid {
        local($addr) = @_;
	    eval q((1));
    }' unless defined(&kern_addr_valid);
}
1;
