require '_h2ph_pre.ph';

unless(defined(&__ALPHA_SYSTEM_H)) {
    eval 'sub __ALPHA_SYSTEM_H () {1;}' unless defined(&__ALPHA_SYSTEM_H);
    require 'linux/config.ph';
    require 'asm/pal.ph';
    require 'asm/page.ph';
    eval 'sub BOOT_PCB () {0x20000000;}' unless defined(&BOOT_PCB);
    eval 'sub BOOT_ADDR () {0x20000000;}' unless defined(&BOOT_ADDR);
    eval 'sub BOOT_SIZE () {(16*1024);}' unless defined(&BOOT_SIZE);
    eval 'sub KERNEL_START () {( &PAGE_OFFSET+0x300000);}' unless defined(&KERNEL_START);
    eval 'sub SWAPPER_PGD () {( &PAGE_OFFSET+0x300000);}' unless defined(&SWAPPER_PGD);
    eval 'sub INIT_STACK () {( &PAGE_OFFSET+0x302000);}' unless defined(&INIT_STACK);
    eval 'sub EMPTY_PGT () {( &PAGE_OFFSET+0x304000);}' unless defined(&EMPTY_PGT);
    eval 'sub EMPTY_PGE () {( &PAGE_OFFSET+0x308000);}' unless defined(&EMPTY_PGE);
    eval 'sub ZERO_PGE () {( &PAGE_OFFSET+0x30a000);}' unless defined(&ZERO_PGE);
    eval 'sub START_ADDR () {( &PAGE_OFFSET+0x310000);}' unless defined(&START_ADDR);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub switch_to {
	    local($prev,$next,$last) = @_;
    	    eval q( &do { \'unsigned long pcbb\';  &current = ($next);  &pcbb =  &virt_to_phys( ($current->{tss})); ($last) =  &alpha_switch_to( &pcbb, ($prev)); }  &while (0));
	}' unless defined(&switch_to);
	eval 'sub mb () {
	    eval q( &__asm__  &__volatile__(\\"mb\\": : :\\"memory\\"));
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q( &__asm__  &__volatile__(\\"mb\\": : :\\"memory\\"));
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q( &__asm__  &__volatile__(\\"wmb\\": : :\\"memory\\"));
	}' unless defined(&wmb);
	eval 'sub imb () {
	    eval q( &__asm__  &__volatile__ (\\"call_pal %0 #imb\\" : : \\"i\\" ( &PAL_imb) : \\"memory\\"));
	}' unless defined(&imb);
	eval 'sub draina () {
	    eval q( &__asm__  &__volatile__ (\\"call_pal %0 #draina\\" : : \\"i\\" ( &PAL_draina) : \\"memory\\"));
	}' unless defined(&draina);
	eval("sub IMPLVER_EV4 () { 0; }") unless defined(&IMPLVER_EV4);
	eval("sub IMPLVER_EV5 () { 1; }") unless defined(&IMPLVER_EV5);
	eval("sub IMPLVER_EV6 () { 2; }") unless defined(&IMPLVER_EV6);
	if(defined(&CONFIG_ALPHA_GENERIC)) {
	    eval 'sub implver () {
	        eval q(({ \'unsigned long __implver\';  &__asm__ (\\"implver %0\\" : \\"=r\\");  &__implver; }));
	    }' unless defined(&implver);
	} else {
	    if(defined(&CONFIG_ALPHA_EV4)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV4);
		}' unless defined(&implver);
	    }
	    if(defined(&CONFIG_ALPHA_EV5)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV5);
		}' unless defined(&implver);
	    }
	    if(defined(&CONFIG_ALPHA_EV6)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV6);
		}' unless defined(&implver);
	    }
	}
	eval("sub AMASK_BWX () { (1UL<<0); }") unless defined(&AMASK_BWX);
	eval("sub AMASK_FIX () { (1UL<<1); }") unless defined(&AMASK_FIX);
	eval("sub AMASK_MAX () { (1UL<<8); }") unless defined(&AMASK_MAX);
	eval("sub AMASK_PRECISE_TRAP () { (1UL<<9); }") unless defined(&AMASK_PRECISE_TRAP);
	eval 'sub amask {
	    local($mask) = @_;
    	    eval q(({ \'unsigned long __amask\',  &__input = ($mask);  &__asm__ (\\"amask %1,%0\\" : \\"=r\\"( &__amask) : \\"rI\\"( &__input));  &__amask; }));
	}' unless defined(&amask);
	eval 'sub __CALL_PAL_R0 {
	    local($NAME, $TYPE) = @_;
    	    eval q( &static  &inline $TYPE $NAME( &void) {  &register $TYPE  &__r0  &__asm__(\\"$0\\");  &__asm__  &__volatile__( \\"call_pal %1 # \\" $NAME :\\"=r\\" ( &__r0) :\\"i\\" ( &PAL_  $NAME) :\\"$1\\", \\"$16\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\");  &return  &__r0; });
	}' unless defined(&__CALL_PAL_R0);
	eval 'sub __CALL_PAL_W1 {
	    local($NAME, $TYPE0) = @_;
    	    eval q( &static  &inline  &void $NAME($TYPE0  &arg0) {  &register $TYPE0  &__r16  &__asm__(\\"$16\\") =  &arg0;  &__asm__  &__volatile__( \\"call_pal %1 # \\"$NAME : \\"=r\\"( &__r16) : \\"i\\"( &PAL_  $NAME), \\"0\\"( &__r16) : \\"$1\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\"); });
	}' unless defined(&__CALL_PAL_W1);
	eval 'sub __CALL_PAL_W2 {
	    local($NAME, $TYPE0, $TYPE1) = @_;
    	    eval q( &static  &inline  &void $NAME($TYPE0  &arg0, $TYPE1  &arg1) {  &register $TYPE0  &__r16  &__asm__(\\"$16\\") =  &arg0;  &register $TYPE1  &__r17  &__asm__(\\"$17\\") =  &arg1;  &__asm__  &__volatile__( \\"call_pal %2 # \\"$NAME : \\"=r\\"( &__r16), \\"=r\\"( &__r17) : \\"i\\"( &PAL_  $NAME), \\"0\\"( &__r16), \\"1\\"( &__r17) : \\"$1\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\"); });
	}' unless defined(&__CALL_PAL_W2);
	eval 'sub __CALL_PAL_RW1 {
	    local($NAME, $RTYPE, $TYPE0) = @_;
    	    eval q( &static  &inline $RTYPE $NAME($TYPE0  &arg0) {  &register $RTYPE  &__r0  &__asm__(\\"$0\\");  &register $TYPE0  &__r16  &__asm__(\\"$16\\") =  &arg0;  &__asm__  &__volatile__( \\"call_pal %2 # \\"$NAME : \\"=r\\"( &__r16), \\"=r\\"( &__r0) : \\"i\\"( &PAL_  $NAME), \\"0\\"( &__r16) : \\"$1\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\");  &return  &__r0; });
	}' unless defined(&__CALL_PAL_RW1);
	eval 'sub __CALL_PAL_RW2 {
	    local($NAME, $RTYPE, $TYPE0, $TYPE1) = @_;
    	    eval q( &static  &inline $RTYPE $NAME($TYPE0  &arg0, $TYPE1  &arg1) {  &register $RTYPE  &__r0  &__asm__(\\"$0\\");  &register $TYPE0  &__r16  &__asm__(\\"$16\\") =  &arg0;  &register $TYPE1  &__r17  &__asm__(\\"$17\\") =  &arg1;  &__asm__  &__volatile__( \\"call_pal %3 # \\"$NAME : \\"=r\\"( &__r16), \\"=r\\"( &__r17), \\"=r\\"( &__r0) : \\"i\\"( &PAL_  $NAME), \\"0\\"( &__r16), \\"1\\"( &__r17) : \\"$1\\", \\"$22\\", \\"$23\\", \\"$24\\", \\"$25\\");  &return  &__r0; });
	}' unless defined(&__CALL_PAL_RW2);
	eval 'sub __cli () {
	    eval q((  &swpipl(7)));
	}' unless defined(&__cli);
	eval 'sub __sti () {
	    eval q((  &swpipl(0)));
	}' unless defined(&__sti);
	eval 'sub __save_flags {
	    local($flags) = @_;
    	    eval q((($flags) =  &rdps()));
	}' unless defined(&__save_flags);
	eval 'sub __save_and_cli {
	    local($flags) = @_;
    	    eval q((($flags) =  &swpipl(7)));
	}' unless defined(&__save_and_cli);
	eval 'sub __restore_flags {
	    local($flags) = @_;
    	    eval q((  &swpipl($flags)));
	}' unless defined(&__restore_flags);
	if(defined(&__SMP__)) {
	    eval 'sub save_and_cli {
	        local($flags) = @_;
    		eval q(( &save_flags($flags),  &cli()));
	    }' unless defined(&save_and_cli);
	    eval 'sub cli () {
	        eval q( &__global_cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__global_sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        local($flags) = @_;
    		eval q((($flags) =  &__global_save_flags()));
	    }' unless defined(&save_flags);
	    eval 'sub restore_flags {
	        local($flags) = @_;
    		eval q( &__global_restore_flags($flags));
	    }' unless defined(&restore_flags);
	} else {
	    eval 'sub cli () {
	        eval q( &__cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        local($flags) = @_;
    		eval q( &__save_flags($flags));
	    }' unless defined(&save_flags);
	    eval 'sub save_and_cli {
	        local($flags) = @_;
    		eval q( &__save_and_cli($flags));
	    }' unless defined(&save_and_cli);
	    eval 'sub restore_flags {
	        local($flags) = @_;
    		eval q( &__restore_flags($flags));
	    }' unless defined(&restore_flags);
	}
	eval 'sub __tbi () {( &nr, &arg, &arg1...) ({  &register  &unsigned long __r16 __asm__("$16") = ( &nr);  &register  &unsigned long __r17 __asm__("$17");  &arg;  &__asm__  &__volatile__( "call_pal %3 #__tbi" :"=r" ( &__r16),"=r" ( &__r17) :"0" ( &__r16),"i" ( &PAL_tbi) , &arg1 :"$0", "$1", "$22", "$23", "$24", "$25"); });}' unless defined(&__tbi);
	eval 'sub tbi {
	    local($x,$y) = @_;
    	    eval q( &__tbi($x, &__r17=($y),\\"1\\" ( &__r17)));
	}' unless defined(&tbi);
	eval 'sub tbisi {
	    local($x) = @_;
    	    eval q( &__tbi(1, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbisi);
	eval 'sub tbisd {
	    local($x) = @_;
    	    eval q( &__tbi(2, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbisd);
	eval 'sub tbis {
	    local($x) = @_;
    	    eval q( &__tbi(3, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbis);
	eval 'sub tbiap () {
	    eval q( &__tbi(-1, ));
	}' unless defined(&tbiap);
	eval 'sub tbia () {
	    eval q( &__tbi(-2, ));
	}' unless defined(&tbia);
	eval 'sub xchg {
	    local($ptr,$x) = @_;
    	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
	}' unless defined(&xchg);
	eval 'sub tas {
	    local($ptr) = @_;
    	    eval q(( &xchg(($ptr),1)));
	}' unless defined(&tas);
	eval 'sub gethere () {
	    eval q(({  &here:  &&  &here; }));
	}' unless defined(&gethere);
    }
}
1;
