require '_h2ph_pre.ph';

unless(defined(&_FCNTL_H)) {
    die("Never use <bits/fcntl.h> directly; include <fcntl.h> instead.");
}
require 'sys/types.ph';
unless(defined(&O_ACCMODE)) {
    sub O_ACCMODE () {	0003;}
}
unless(defined(&O_RDONLY)) {
    sub O_RDONLY () {	00;}
}
unless(defined(&O_WRONLY)) {
    sub O_WRONLY () {	01;}
}
unless(defined(&O_RDWR)) {
    sub O_RDWR () {	02;}
}
unless(defined(&O_CREAT)) {
    sub O_CREAT () {	01000;}
}
unless(defined(&O_TRUNC)) {
    sub O_TRUNC () {	02000;}
}
unless(defined(&O_EXCL)) {
    sub O_EXCL () {	04000;}
}
unless(defined(&O_NOCTTY)) {
    sub O_NOCTTY () {	010000;}
}
unless(defined(&O_NONBLOCK)) {
    sub O_NONBLOCK () {	00004;}
}
unless(defined(&O_APPEND)) {
    sub O_APPEND () {	00010;}
}
unless(defined(&O_NDELAY)) {
    sub O_NDELAY () {	 &O_NONBLOCK;}
}
unless(defined(&O_SYNC)) {
    sub O_SYNC () {	040000;}
}
unless(defined(&O_FSYNC)) {
    sub O_FSYNC () {	 &O_SYNC;}
}
unless(defined(&O_ASYNC)) {
    sub O_ASYNC () {	020000;}
}
if(defined(&__USE_GNU)) {
    eval 'sub O_DIRECT () {040000;}' unless defined(&O_DIRECT);
    eval 'sub O_DIRECTORY () {0100000;}' unless defined(&O_DIRECTORY);
    eval 'sub O_NOFOLLOW () {0200000;}' unless defined(&O_NOFOLLOW);
}
unless(defined(&O_LARGEFILE)) {
    sub O_LARGEFILE () {	0;}
}
unless(defined(&F_DUPFD)) {
    sub F_DUPFD () {	0;}
}
unless(defined(&F_GETFD)) {
    sub F_GETFD () {	1;}
}
unless(defined(&F_SETFD)) {
    sub F_SETFD () {	2;}
}
unless(defined(&F_GETFL)) {
    sub F_GETFL () {	3;}
}
unless(defined(&F_SETFL)) {
    sub F_SETFL () {	4;}
}
unless(defined(&F_GETLK)) {
    sub F_GETLK () {	7;}
}
unless(defined(&F_SETLK)) {
    sub F_SETLK () {	8;}
}
unless(defined(&F_SETLKW)) {
    sub F_SETLKW () {	9;}
}
unless(defined(&F_GETLK64)) {
    sub F_GETLK64 () {	7;}
}
unless(defined(&F_SETLK64)) {
    sub F_SETLK64 () {	8;}
}
unless(defined(&F_SETLKW64)) {
    sub F_SETLKW64 () {	9;}
}
if(defined(&__USE_BSD)) {
    eval 'sub F_SETOWN () {5;}' unless defined(&F_SETOWN);
    eval 'sub F_GETOWN () {6;}' unless defined(&F_GETOWN);
}
if(defined(&__USE_GNU)) {
    eval 'sub F_SETSIG () {10;}' unless defined(&F_SETSIG);
    eval 'sub F_GETSIG () {11;}' unless defined(&F_GETSIG);
}
unless(defined(&FD_CLOEXEC)) {
    sub FD_CLOEXEC () {	1;}
}
unless(defined(&F_RDLCK)) {
    sub F_RDLCK () {	1;}
}
unless(defined(&F_WRLCK)) {
    sub F_WRLCK () {	2;}
}
unless(defined(&F_UNLCK)) {
    sub F_UNLCK () {	8;}
}
unless(defined(&F_EXLCK)) {
    sub F_EXLCK () {	16;}
}
unless(defined(&F_SHLCK)) {
    sub F_SHLCK () {	32;}
}
if(defined(&__USE_BSD)) {
    eval 'sub LOCK_SH () {1;}' unless defined(&LOCK_SH);
    eval 'sub LOCK_EX () {2;}' unless defined(&LOCK_EX);
    eval 'sub LOCK_NB () {4;}' unless defined(&LOCK_NB);
    eval 'sub LOCK_UN () {8;}' unless defined(&LOCK_UN);
}
if(defined(&__USE_LARGEFILE64)) {
}
if(defined(&__USE_BSD)) {
    eval 'sub FAPPEND () { &O_APPEND;}' unless defined(&FAPPEND);
    eval 'sub FFSYNC () { &O_FSYNC;}' unless defined(&FFSYNC);
    eval 'sub FASYNC () { &O_ASYNC;}' unless defined(&FASYNC);
    eval 'sub FNONBLOCK () { &O_NONBLOCK;}' unless defined(&FNONBLOCK);
    eval 'sub FNDELAY () { &O_NDELAY;}' unless defined(&FNDELAY);
}
1;
