require '_h2ph_pre.ph';

if(defined(&__KERNEL__)) {
    unless(defined(&_LINUX_ISDN_COMPAT_H)) {
	eval 'sub _LINUX_ISDN_COMPAT_H () {1;}' unless defined(&_LINUX_ISDN_COMPAT_H);
	unless(defined(&LINUX_VERSION_CODE)) {
	    require 'linux/version.ph';
	}
	unless(defined(&KERNEL_VERSION)) {
	    eval 'sub KERNEL_VERSION {
	        local($x,$y,$z) = @_;
    		eval q(((($x)<<16)+(($y)<<8)+($z)));
	    }' unless defined(&KERNEL_VERSION);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,0)) {
	    require 'linux/mm.ph';
	    eval 'sub ioremap () { &vremap;}' unless defined(&ioremap);
	    eval 'sub ioremap_nocache () { &vremap;}' unless defined(&ioremap_nocache);
	    eval 'sub iounmap () { &vfree;}' unless defined(&iounmap);
	    eval 'sub GET_USER {
	        local($x, $addr) = @_;
    		eval q(( $x =  &get_user($addr) ));
	    }' unless defined(&GET_USER);
	    if(defined(&__alpha__)) {
		eval 'sub RWTYPE () {\'long\';}' unless defined(&RWTYPE);
		eval 'sub LSTYPE () {\'long\';}' unless defined(&LSTYPE);
		eval 'sub RWARG () {\'unsigned long\';}' unless defined(&RWARG);
	    } else {
		eval 'sub RWTYPE () {\'int\';}' unless defined(&RWTYPE);
		eval 'sub LSTYPE () {\'int\';}' unless defined(&LSTYPE);
		eval 'sub RWARG () {\'int\';}' unless defined(&RWARG);
	    }
	    eval 'sub LSARG () { &off_t;}' unless defined(&LSARG);
	} else {
	    require 'asm/uaccess.ph';
	    eval 'sub GET_USER () { &get_user;}' unless defined(&GET_USER);
	    eval 'sub PUT_USER () { &put_user;}' unless defined(&PUT_USER);
	    eval 'sub RWTYPE () {\'long\';}' unless defined(&RWTYPE);
	    eval 'sub LSTYPE () {\'long long\';}' unless defined(&LSTYPE);
	    eval 'sub RWARG () {\'unsigned long\';}' unless defined(&RWARG);
	    eval 'sub LSARG () {\'long long\';}' unless defined(&LSARG);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,15)) {
	    eval 'sub SET_SKB_FREE {
	        local($x) = @_;
    		eval q((  ($x->{free}) = 1));
	    }' unless defined(&SET_SKB_FREE);
	    eval 'sub idev_kfree_skb {
	        local($a,$b) = @_;
    		eval q( &dev_kfree_skb($a,$b));
	    }' unless defined(&idev_kfree_skb);
	} else {
	    eval 'sub SET_SKB_FREE {
	        local($x) = @_;
    		eval q();
	    }' unless defined(&SET_SKB_FREE);
	    eval 'sub idev_kfree_skb {
	        local($a,$b) = @_;
    		eval q( &dev_kfree_skb($a));
	    }' unless defined(&idev_kfree_skb);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,1,18)) {
	    eval 'sub COMPAT_HAS_NEW_SYMTAB () {1;}' unless defined(&COMPAT_HAS_NEW_SYMTAB);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,31)) {
	    eval 'sub CLOSETYPE () { &void;}' unless defined(&CLOSETYPE);
	    eval 'sub CLOSEVAL () {1;}' unless defined(&CLOSEVAL);
	} else {
	    eval 'sub CLOSETYPE () {\'int\';}' unless defined(&CLOSETYPE);
	    eval 'sub CLOSEVAL () {(0);}' unless defined(&CLOSEVAL);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,37)) {
	    eval 'sub test_and_clear_bit () { &clear_bit;}' unless defined(&test_and_clear_bit);
	    eval 'sub test_and_set_bit () { &set_bit;}' unless defined(&test_and_set_bit);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,81)) {
	    eval 'sub kstat_irqs {
	        local( $PAR ) = @_;
    		eval q( ($kstat->{interrupts[$PAR]}));
	    }' unless defined(&kstat_irqs);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >  &KERNEL_VERSION(2,1,91)) {
	    eval 'sub COMPAT_HAS_NEW_PCI () {1;}' unless defined(&COMPAT_HAS_NEW_PCI);
	    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,3,13)) {
		eval 'sub get_pcibase {
		    local($ps, $nr) = @_;
    		    eval q( ($ps->{base_address[$nr]}));
		}' unless defined(&get_pcibase);
	    } else {
		eval 'sub get_pcibase {
		    local($ps, $nr) = @_;
    		    eval q( ($ps->{resource[$nr]}->{start}));
		}' unless defined(&get_pcibase);
	    }
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,1,127)) {
	    eval 'sub schedule_timeout {
	        local($a) = @_;
    		eval q( ($current->{timeout}) =  &jiffies + ($a);  &schedule (););
	    }' unless defined(&schedule_timeout);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >  &KERNEL_VERSION(2,3,0)) {
	    eval 'sub COMPAT_HAS_NEW_WAITQ () {1;}' unless defined(&COMPAT_HAS_NEW_WAITQ);
	}
    }
}
1;
