require '_h2ph_pre.ph';

unless(defined(&_LINUX_JOYSTICK_H)) {
    eval 'sub _LINUX_JOYSTICK_H () {1;}' unless defined(&_LINUX_JOYSTICK_H);
    require 'asm/types.ph';
    require 'linux/module.ph';
    eval 'sub JS_VERSION () {0x01020d;}' unless defined(&JS_VERSION);
    eval 'sub JS_EVENT_BUTTON () {0x01;}' unless defined(&JS_EVENT_BUTTON);
    eval 'sub JS_EVENT_AXIS () {0x02;}' unless defined(&JS_EVENT_AXIS);
    eval 'sub JS_EVENT_INIT () {0x80;}' unless defined(&JS_EVENT_INIT);
    eval 'sub JSIOCGVERSION () { &_IOR(ord(\'j\'), 0x01,  &__u32);}' unless defined(&JSIOCGVERSION);
    eval 'sub JSIOCGAXES () { &_IOR(ord(\'j\'), 0x11,  &__u8);}' unless defined(&JSIOCGAXES);
    eval 'sub JSIOCGBUTTONS () { &_IOR(ord(\'j\'), 0x12,  &__u8);}' unless defined(&JSIOCGBUTTONS);
    eval 'sub JSIOCGNAME {
        local($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'j\'), 0x13, $len));
    }' unless defined(&JSIOCGNAME);
    eval 'sub JSIOCSCORR () { &_IOW(ord(\'j\'), 0x21, \'struct js_corr\');}' unless defined(&JSIOCSCORR);
    eval 'sub JSIOCGCORR () { &_IOR(ord(\'j\'), 0x22, \'struct js_corr\');}' unless defined(&JSIOCGCORR);
    eval 'sub JS_CORR_NONE () {0x00;}' unless defined(&JS_CORR_NONE);
    eval 'sub JS_CORR_BROKEN () {0x01;}' unless defined(&JS_CORR_BROKEN);
    eval 'sub JS_RETURN () {$sizeof{\'struct JS_DATA_TYPE\'};}' unless defined(&JS_RETURN);
    eval 'sub JS_TRUE () {1;}' unless defined(&JS_TRUE);
    eval 'sub JS_FALSE () {0;}' unless defined(&JS_FALSE);
    eval 'sub JS_X_0 () {0x01;}' unless defined(&JS_X_0);
    eval 'sub JS_Y_0 () {0x02;}' unless defined(&JS_Y_0);
    eval 'sub JS_X_1 () {0x04;}' unless defined(&JS_X_1);
    eval 'sub JS_Y_1 () {0x08;}' unless defined(&JS_Y_1);
    eval 'sub JS_MAX () {2;}' unless defined(&JS_MAX);
    eval 'sub JS_DEF_TIMEOUT () {0x1300;}' unless defined(&JS_DEF_TIMEOUT);
    eval 'sub JS_DEF_CORR () {0;}' unless defined(&JS_DEF_CORR);
    eval 'sub JS_DEF_TIMELIMIT () {10;}' unless defined(&JS_DEF_TIMELIMIT);
    eval 'sub JS_SET_CAL () {1;}' unless defined(&JS_SET_CAL);
    eval 'sub JS_GET_CAL () {2;}' unless defined(&JS_GET_CAL);
    eval 'sub JS_SET_TIMEOUT () {3;}' unless defined(&JS_SET_TIMEOUT);
    eval 'sub JS_GET_TIMEOUT () {4;}' unless defined(&JS_GET_TIMEOUT);
    eval 'sub JS_SET_TIMELIMIT () {5;}' unless defined(&JS_SET_TIMELIMIT);
    eval 'sub JS_GET_TIMELIMIT () {6;}' unless defined(&JS_GET_TIMELIMIT);
    eval 'sub JS_GET_ALL () {7;}' unless defined(&JS_GET_ALL);
    eval 'sub JS_SET_ALL () {8;}' unless defined(&JS_SET_ALL);
    if(defined(&__KERNEL__)) {
	eval 'sub JS_BUFF_SIZE () {64;}' unless defined(&JS_BUFF_SIZE);
	require 'linux/version.ph';
	unless(defined(&KERNEL_VERSION)) {
	    eval 'sub KERNEL_VERSION {
	        local($a,$b,$c) = @_;
    		eval q(((($a) << 16) + (($b) << 8) + ($c)));
	    }' unless defined(&KERNEL_VERSION);
	}
	unless(defined(&LINUX_VERSION_CODE)) {
	    die("You need to use at least 2.0 Linux kernel.");
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <  &KERNEL_VERSION(2,0,0)) {
	    die("You need to use at least 2.0 Linux kernel.");
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,1,0)) {
	    eval 'sub JS_HAS_RDTSC () {( ($current_cpu_data->{x86_capability}) & 0x10);}' unless defined(&JS_HAS_RDTSC);
	    require 'linux/init.ph';
	} else {
	    if(defined(&MODULE)) {
		if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,0,35)) {
		    eval 'sub JS_HAS_RDTSC () {( &x86_capability & 0x10);}' unless defined(&JS_HAS_RDTSC);
		} else {
		    eval 'sub JS_HAS_RDTSC () {0;}' unless defined(&JS_HAS_RDTSC);
		}
	    } else {
		eval 'sub JS_HAS_RDTSC () {( &x86_capability & 0x10);}' unless defined(&JS_HAS_RDTSC);
	    }
	    eval 'sub __initdata () {1;}' unless defined(&__initdata);
	    eval 'sub __init () {1;}' unless defined(&__init);
	    eval 'sub __cli () { &cli;}' unless defined(&__cli);
	    eval 'sub __save_flags {
	        local($flags) = @_;
    		eval q( &save_flags($flags));
	    }' unless defined(&__save_flags);
	    eval 'sub __restore_flags {
	        local($flags) = @_;
    		eval q( &restore_flags($flags));
	    }' unless defined(&__restore_flags);
	    eval 'sub spin_lock_irqsave {
	        local($x, $flags) = @_;
    		eval q( &do {  &save_flags($flags);  &cli(); }  &while (0));
	    }' unless defined(&spin_lock_irqsave);
	    eval 'sub spin_unlock_irqrestore {
	        local($x, $flags) = @_;
    		eval q( &restore_flags($flags));
	    }' unless defined(&spin_unlock_irqrestore);
	    eval 'sub spin_lock_init {
	        local($x) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&spin_lock_init);
	    eval 'sub SPIN_LOCK_UNLOCKED () {{ 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	    eval 'sub MODULE_AUTHOR {
	        local($x) = @_;
    		eval q();
	    }' unless defined(&MODULE_AUTHOR);
	    eval 'sub MODULE_PARM {
	        local($x,$y) = @_;
    		eval q();
	    }' unless defined(&MODULE_PARM);
	    eval 'sub MODULE_SUPPORTED_DEVICE {
	        local($x) = @_;
    		eval q();
	    }' unless defined(&MODULE_SUPPORTED_DEVICE);
	    eval 'sub signal_pending {
	        local($x) = @_;
    		eval q(((($x)-> &signal) & ~(($x)-> &blocked)));
	    }' unless defined(&signal_pending);
	}
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) >=  &KERNEL_VERSION(2,1,0)) {
	    eval 'sub USE_PARPORT () {1;}' unless defined(&USE_PARPORT);
	}
	if(defined(&USE_PARPORT)) {
	    require 'linux/parport.ph';
	    eval 'sub JS_PAR_DATA_IN {
	        local($y) = @_;
    		eval q( &parport_read_data( ($y->{port})));
	    }' unless defined(&JS_PAR_DATA_IN);
	    eval 'sub JS_PAR_DATA_OUT {
	        local($x,$y) = @_;
    		eval q( &parport_write_data( ($y->{port}), $x));
	    }' unless defined(&JS_PAR_DATA_OUT);
	    eval 'sub JS_PAR_STATUS {
	        local($y) = @_;
    		eval q( &parport_read_status( ($y->{port})));
	    }' unless defined(&JS_PAR_STATUS);
	    eval 'sub JS_PAR_CTRL_IN {
	        local($y) = @_;
    		eval q( &parport_read_control( ($y->{port})));
	    }' unless defined(&JS_PAR_CTRL_IN);
	    eval 'sub JS_PAR_CTRL_OUT {
	        local($x,$y) = @_;
    		eval q( &parport_write_control( ($y->{port}), $x));
	    }' unless defined(&JS_PAR_CTRL_OUT);
	    eval 'sub JS_PAR_ECTRL_OUT {
	        local($x,$y) = @_;
    		eval q( &parport_write_econtrol( ($y->{port}), $x));
	    }' unless defined(&JS_PAR_ECTRL_OUT);
	} else {
	    eval 'sub JS_PAR_DATA_IN {
	        local($y) = @_;
    		eval q( &inb($y));
	    }' unless defined(&JS_PAR_DATA_IN);
	    eval 'sub JS_PAR_DATA_OUT {
	        local($x,$y) = @_;
    		eval q( &outb($x,$y));
	    }' unless defined(&JS_PAR_DATA_OUT);
	    eval 'sub JS_PAR_STATUS {
	        local($y) = @_;
    		eval q( &inb($y+1));
	    }' unless defined(&JS_PAR_STATUS);
	    eval 'sub JS_PAR_CTRL_IN {
	        local($y) = @_;
    		eval q( &inb($y+2));
	    }' unless defined(&JS_PAR_CTRL_IN);
	    eval 'sub JS_PAR_CTRL_OUT {
	        local($x,$y) = @_;
    		eval q( &outb($x,$y+2));
	    }' unless defined(&JS_PAR_CTRL_OUT);
	    eval 'sub JS_PAR_ECTRL_OUT {
	        local($x,$y) = @_;
    		eval q( &outb($x,$y+0x402));
	    }' unless defined(&JS_PAR_ECTRL_OUT);
	}
	eval 'sub JS_PAR_STATUS_INVERT () {(0x80);}' unless defined(&JS_PAR_STATUS_INVERT);
	eval 'sub JS_PAR_CTRL_INVERT () {(0x04);}' unless defined(&JS_PAR_CTRL_INVERT);
    }
}
1;
